# Upgrading Connectware to 2.1.0 (Docker)

Connectware 2.1.0 introduces support for the Siemens SIMATIC S7+ protocol and OPC UA complex data types. It also reintroduces service-level tracking for the Systemstate protocol, offering improved performance. Furthermore, it provides significant enhancements to resource deviation tracking and OPC UA reliability. For a complete list of changes, see the [2.1.0 changelog](https://docs.cybus.io/2-1-2/documentation/installation-and-upgrades/upgrading-connectware/upgrading-connectware-docker/pages/0F22SWN9NNNKBU2GJWbW#what-has-changed-in-2.1.0).

{% stepper %}
{% step %}

### Upgrading Connectware to 2.1.0

Follow the instructions in [Upgrading Connectware (Docker)](/2-1-2/documentation/installation-and-upgrades/upgrading-connectware/upgrading-connectware-docker.md) to upgrade to version 2.1.0.
{% endstep %}

{% step %}

### Optional: Cleaning Up Disk Space After Upgrading to 2.1.0

As part of the Systemstate improvements in 2.1.0, the `resourceStates` NATS bucket is no longer used. If you want to save disk space, you can delete this bucket.

* To clean up disk space, run the following:

{% code lineNumbers="true" %}

```bash
CW_SCS_CONTAINER=$(docker container ls -q -f "label=io.cybus.connectware=core" -f "label=com.docker.compose.service=system-control-server")
docker run --rm -it \
-v $(docker inspect ${CW_SCS_CONTAINER}  | jq -r '.[].Mounts[] | select(.Destination == "/connectware_certs") | .Name'):/connectware_certs \
--network=container:${CW_SCS_CONTAINER} \
--pid=container:${CW_SCS_CONTAINER} \
registry.cybus.io/cybus/connectware-toolkit:1.4.0 -c 'source /connectware_certs/env-1.0.sh && nats -s nats:4222 --user cybus_auth --password $CYBUS_NATS_AUTH_PASSWORD --tlscert=/connectware_certs/cybus_client.crt --tlskey=/connectware_certs/cybus_client.key --tlsca=/connectware_certs/cybus_combined_ca.crt kv del resourceStates -f'
```

{% endcode %}
{% endstep %}
{% endstepper %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cybus.io/2-1-2/documentation/installation-and-upgrades/upgrading-connectware/upgrading-connectware-docker/upgrading-connectware-to-2-1-0-docker.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
